<template>
  <header v-if="isHeaderShow">
    <h1 class="sr-only">Dark Theme</h1>
    <div
      class="flex items-center pl-3.5 pr-3.5 py-[0.569rem] border-b4 bg-background3"
    >
      <div class="w-1/2 logo" v-if="!logo.IsHidden">
        <nuxt-link :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
          <figure class="w-[59%] h-auto">
            <img :src="logo.ImagePath" alt="Dark Theme" />
          </figure>
        </nuxt-link>
      </div>
      <div class="flex items-center w-1/2 gap-3 mr-2" v-if="isd9betUnauth">
        <button @click="toggleAuthModal('login')" class="btn bg-secondary">
          <span class="text-base font-bold leading-4">{{
            $t("capital_login")
          }}</span>
        </button>
        <button v-if="!register.IsHidden"  @click="toggleAuthModal('register')" class="btn bg-primary" :id="ID.SIGNUP">
          <span class="text-base font-bold leading-4 pointer-events-none">{{ $t("joinnow") }}</span>
        </button>
      </div>
      <div v-else class="flex justify-end w-1/2 items-center">
        <theme-mobile-black-components-ui-balance-info
          v-if="auth"
          :isSuspended="false"
        />
        <new-black-theme-hamburger-menu />
      </div>
    </div>
    <div
      class="py-2 bg-background2 h-[32px]"
      v-if="includeAnnouncement && !announcement.IsHidden"
    >
      <div class="container flex items-center h-full mx-auto">
        <theme-mobile-black-components-ui-announcement
          :announcement="announcement.Text"
        />
      </div>
    </div>
  </header>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

const shownRoute = [
  "home",
  "sports",
  "virtual-sports",
  "live-casino",
  "games",
  "game-entry",
  "keno",
  "poker",
  "cockfight",
  "lottery",
  "promotion",
  "index",
];

export default defineComponent({
  props: {
    auth: {
      type: Boolean,
      default: false,
    },
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    includeAnnouncement: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  setup(props) {
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "logo"
        )
    );
    const route = useRoute();
    const { name } = toRefs(route);
    const isHeaderShow = computed(() =>
      shownRoute.includes(name.value as string)
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const { getAssetImage } = commonHelper;
    const isd9betUnauth = computed(
      () => store.state.selectedThemeName.includes("black") && !store.state.auth
    );
    const register = computed(() =>
      themePropertyHelper.getSingleThemeProperty(
        store.state.companyThemePropertiesFromApi.ThemeProperties,
        "register"
      )
    );
    const toggleAuthModal = (option: "login" | "register"): void => {
      if (option === "login") {
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
      if (option === "register") {
        store.commit("updateRegisterDialog", !store.state.showRegisterDialog);
      }
    };
    return {
      logo,
      isHeaderShow,
      getAssetImage,
      toggleAuthModal,
      isd9betUnauth,
      announcement,
      register,
    };
  },
});
</script>
<style scoped>
.btn {
  @apply inline-block text-center rounded-2xl transition-colors duration-300;
  padding: 0.18rem 0 !important;
  width: 90px;
  min-width: 90px;
}
</style>
